local Sprite={}

local ffi = require('ffi')

local function Render(pixels)
  -- Get an FFI pointer to the pixel data
  local ptr = ffi.cast('uint32_t *', pixels:getFFIPointer())

  -- Some values we'll need more than once
  local width = pixels:getWidth()
  local halfWidth = width / 2
  local height = pixels:getHeight()
  local halfHeight = height / 2

  local function setPixel(spX, spY, Datalist)
    -- Some sanity checks.
    assert(spX >= -halfWidth and spX < halfWidth)
    assert(spY >= -halfHeight and spY < halfHeight)
    assert(spX == math.floor(spX) and spY == math.floor(spY))

    -- Calculate offset into the buffer, applying centre of the screen.
    local idx = (spY + halfHeight) * width + (spX + halfWidth)
    -- All white, full opacity
    ptr[idx] = 0xFFFFFFFF
    end

  Sprite.x = halfWidth - 1
  Sprite.y = halfHeight - 1
  for i=1, width * height do
    if Sprite.x < -halfWidth then
      Sprite.y = Sprite.y - 1
      Sprite.x = halfWidth - 1
      end
    setPixel(Sprite.x, Sprite.y)
    Sprite.x = Sprite.x - 1
    end
  end    

return Render
