

-- Load the rendering function.
local renderFunc = require('Render')

-- Create the pixel buffer.
local pixels = love.image.newImageData(love.graphics.getDimensions())

-- Create a base image, to be replaced later.
local image = love.graphics.newImage(pixels)


function love.update(dt)
    -- Render to the pixel buffer.
    renderFunc(pixels)
    -- Replace the image contents with the new pixel buffer.
    image:replacePixels(pixels)
    end

function love.draw()
    -- Show the FPS in the title of the window
    love.window.setTitle(love.timer.getFPS())

    -- Draw the image to the screen in one single OpenGL draw operation.
    love.graphics.draw(image)
    end
